#include "filterimage.h"

 void PVC_Kernel::resize ( int width, int height ){ 
	 PVC_Image::resize( width, height ); 
	 halfsize_value = (int)floor( float(w() / 2) ); 
 };

void Filter_Image::normalize()
{
	float* data= get_data();
	float minVal= numeric_limits<float>::max();
	float maxVal= numeric_limits<float>::min();

	for (int i= 0; i<w()*h()*4; i++)
	{
		if (data[i]<minVal)
			minVal= data[i];
		if (data[i]>maxVal)
			maxVal= data[i];
	}
	for (int i= 0; i<w()*h()*4; i++)
	{
		const float value= data[i];
		data[i]= (value-minVal)/(maxVal-minVal);
	}
}


PVC_Image_Gray *Filter_Image::substractToGray( Filter_Image* im )
{
	assert(w() == im->w() && h() == im->h());
	PVC_Image_Gray* result= new PVC_Image_Gray();
	result->resize(w(), h());

	float* data1= get_data();
	float* data2= im->get_data();
	float* dataResult= result->get_data();

	for (int i= 0; i<w()*h(); i++)
	{
		float gray1= 0.0f;
		float gray2= 0.0f;
		for (int c= 0; c<3; c++)
		{
			gray1+= data1[i*4+c];
			gray2+= data2[i*4+c];
		}
		gray1/=3;
		gray2/=3;
		dataResult[i]= gray1-gray2;
	}

	return result;
}
