uniform sampler2D inputImageSampler2D;
uniform int kernelSize;
uniform float SIGMA;
uniform float SIGMA_INTENSITY;

void main() {
        float PI = 3.14159265358979323846264;

	vec4 sum = vec4(0);
	vec4 imgval = vec4(0);
	float kval = 0.0;
	float sumweights = 0.0;
	float centerval;

	SIGMA = 5.0;
	SIGMA_INTENSITY = 0.2;
	
	centerval = texelFetch(inputImageSampler2D, textureSize(inputImageSampler2D,0) - ivec2(1) - ivec2(gl_FragCoord.xy), 0);

	for(int i = -kernelSize; i <= kernelSize; i++) {
		for(int j = -kernelSize; j <= kernelSize; j++) {
			imgval = texelFetch(inputImageSampler2D, textureSize(inputImageSampler2D,0) - ivec2(1) - ivec2(gl_FragCoord.xy) + ivec2(j, i), 0);
			
			float square = imgval - centerval;
			square *=square;
			
			kval = exp(-((float)i*i + (float)j*j)/(2.0*SIGMA*SIGMA)) * exp( - square / ( 2 * SIGMA_INTENSITY * SIGMA_INTENSITY ) );
	
			sumweights += kval;

			sum += kval * imgval;
		}
	}
//	sum /= (2 * kernelSize + 1) * (2 * kernelSize + 1) * 10;

	gl_FragColor = sum / sumweights;
}
